#!/usr/bin/env python

import os
import time
import sys
import string
import cgi

import ssx

import imp

def handle_module(xml, module, path = ['.'], **kw):
	if len(module) and module[0] == '/': module = module[1:]
        request = module
	if len(module) and module[-1] == '/': module = module[:-1]
	module = string.replace(module, '/', '.')
        module = module or 'index'
        #XXX: When fd returned by find_module have to be closed?
        try:
                mh = imp.find_module(module, path)
        except ImportError, e:
                os.stat(request)
                raise e
        sub = imp.load_module(module, *mh)
	return sub.handler(xml, **kw)

def main(docbase = '',xsl = 'ssx/ssx.xslt', xmlns = {}, xmlextra = "", output = 'xslt', xmlbase = None, **kw):
	xml = ssx.SSXML() 
	xml.data("<?xml-stylesheet type='application/xslt+xml' href='%s%s'?>\n" % (docbase, xsl))
	xml.push("ssx:doc", """
		xmlns='http://www.w3.org/1999/xhtml'
		xmlns:xi='http://www.w3.org/2001/XInclude'
		xmlns:ssx='%s'
                %s
		""" % (ssx.xmlns, "\n".join(map(lambda x: "xmlns:%s='%s'" % x, xmlns.items()))))
	if xmlbase: xml.data("<ssx:base>%s</ssx:base>\n" % xmlbase)

	module = os.environ.get("PATH_INFO", "index")

	timer = time.time()

	xml.push("ssx:body")
        xml.data(xmlextra)
	try:
		try:
			xml = handle_module(xml, module, **kw) or xml
		finally:
			xml.pop("ssx:body")
	except ssx.SSXRedirect, e:
		sys.stdout.write("Status: 301 Moved Permanantly\n")
		sys.stdout.write("Location: %s\n\n" % (e.url))
		return 
	except ImportError, e:
		sys.stdout.write("Status: 302 Found\n")
		#sys.stdout.write("Status: 301 Moved Permanantly\n")
		sys.stdout.write("Location: %s%s\n\n" % (docbase, module))
		return
	except RuntimeError, e:
		xml.data("<ssx:error>"+ ssx.xmlq(e) +"</ssx:error>\n");
	except Exception, e:
		#xml.data("<ssx:error>Internal error</ssx:error>\n");
		import traceback
		xml.data("<ssx:error>%s<pre>%s</pre></ssx:error>" % (ssx.xmlq(e), ssx.xmlq(traceback.format_exc())))
	except:
		xml.data("<ssx:error>Internal error</ssx:error>\n");

	xml.push("ssx:meta")
	xml.data("<ssx:line>"+time.ctime()+"</ssx:line>\n");
	#xml.data("<ssx:timer type='web'>%.3f</ssx:timer>" % (timer - req.request_time))
	xml.data("<ssx:timer type='query'>%.3f</ssx:timer>" % (time.time() - timer))
	#if output != "xml":
	xml.data("<ssx:timer type='xslt'><xslt-timing/></ssx:timer>")
	#	sep = "?"
		#if req.unparsed_uri.find('?') > 0:
		#	sep = '&amp;'
		#xml.data("<ssx:line><a href='%s%soutput=xml'>xml</a></ssx:line>\n" % (ssx.xmlq(req.unparsed_uri), sep))
	xml.pop()

	timer = time.time()
	if output == "xml":
		sys.stdout.write("Content-Type: text/xml; charset=UTF-8\n\n")
		sys.stdout.write(xml.text());
		return
	
	xslt = ssx.SSXSLT(xsl)
	#xslt = ssx.SSXSLT(document_root + "/" + xsl)
	tmp = xslt.xslt(xml = xml.xml(xi = True))
	tmp = string.replace(tmp, "<xslt-timing/>", "%.3f" % (time.time() - timer))

	sys.stdout.write("Content-Type: text/xml\n\n")
	sys.stdout.write(tmp)

if __name__ == "__main__":
	try:
		main("xslt/mgp.xslt", "xslt")
	except Exception, e:
		sys.stdout.write("Content-Type: text/plain\n\n")
		sys.stdout.write(str(e))
		import traceback
		s
